/* szClock - Detect your pentium clock using rdtsc istruction
 *
 * Copyright (C) 2004 Giuseppe Caulo <giusc@softzone.it>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define PERIOD 1

#ifdef __GNUC__
#ifndef __int64
#define __int64 long long
#endif
#endif

unsigned __int64 rdtsc()
{
	unsigned __int64 x;
#ifdef _MSC_VER
	unsigned __int64 *dest = &x;
	__asm
	{
		    _emit 0xf
			_emit 0x31
			mov esi, dest
			mov [esi], eax
			mov [esi+4], edx
	}
#else
    __asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));
#endif
    return x;
}

void mhz()
{
	static __int64 told = 0, tnew;
	tnew = rdtsc();
	if (told != 0)
	{
		printf("%Ld Hz ", (tnew-told)/PERIOD);
		printf("(%Ld Mhz)\n", (tnew-told)/(1000000*PERIOD));
	}
	told = tnew;
}

int main()
{
	time_t t;

	t = time(NULL)+1;
	while(1)
	{
		while(time(NULL) != t);
		mhz(NULL);
		t=time(NULL)+PERIOD;
	}
}

